/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import * as cdktf from 'cdktf';
import { Wafv2RuleGroupRuleStatementSizeConstraintStatementFieldToMatch, Wafv2RuleGroupRuleStatementSizeConstraintStatementFieldToMatchOutputReference, Wafv2RuleGroupRuleStatementRateBasedStatement, Wafv2RuleGroupRuleStatementRateBasedStatementOutputReference, Wafv2RuleGroupRuleStatementRegexMatchStatement, Wafv2RuleGroupRuleStatementRegexMatchStatementOutputReference, Wafv2RuleGroupRuleStatementRegexPatternSetReferenceStatement, Wafv2RuleGroupRuleStatementRegexPatternSetReferenceStatementOutputReference } from './structs6400';
import { Wafv2RuleGroupRuleStatementAndStatement, Wafv2RuleGroupRuleStatementAndStatementOutputReference, Wafv2RuleGroupRuleStatementByteMatchStatement, Wafv2RuleGroupRuleStatementByteMatchStatementOutputReference, Wafv2RuleGroupRuleStatementGeoMatchStatement, Wafv2RuleGroupRuleStatementGeoMatchStatementOutputReference, Wafv2RuleGroupRuleStatementIpSetReferenceStatement, Wafv2RuleGroupRuleStatementIpSetReferenceStatementOutputReference, Wafv2RuleGroupRuleStatementLabelMatchStatement, Wafv2RuleGroupRuleStatementLabelMatchStatementOutputReference } from './structs400';
import { Wafv2RuleGroupRuleStatementNotStatement, Wafv2RuleGroupRuleStatementNotStatementOutputReference } from './structs800';
import { Wafv2RuleGroupRuleStatementOrStatement, Wafv2RuleGroupRuleStatementOrStatementOutputReference } from './structs1200';
import { Wafv2RuleGroupRuleAction, Wafv2RuleGroupRuleActionOutputReference, Wafv2RuleGroupRuleCaptchaConfig, Wafv2RuleGroupRuleCaptchaConfigOutputReference, Wafv2RuleGroupRuleRuleLabel, Wafv2RuleGroupRuleRuleLabelList } from './structs0';
export interface Wafv2RuleGroupRuleStatementSizeConstraintStatementTextTransformation {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#priority Wafv2RuleGroup#priority}
    */
    readonly priority: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#type Wafv2RuleGroup#type}
    */
    readonly type: string;
}
export declare function wafv2RuleGroupRuleStatementSizeConstraintStatementTextTransformationToTerraform(struct?: Wafv2RuleGroupRuleStatementSizeConstraintStatementTextTransformation | cdktf.IResolvable): any;
export declare class Wafv2RuleGroupRuleStatementSizeConstraintStatementTextTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): Wafv2RuleGroupRuleStatementSizeConstraintStatementTextTransformation | cdktf.IResolvable | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementSizeConstraintStatementTextTransformation | cdktf.IResolvable | undefined);
    private _priority?;
    get priority(): number;
    set priority(value: number);
    get priorityInput(): number | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
}
export declare class Wafv2RuleGroupRuleStatementSizeConstraintStatementTextTransformationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: Wafv2RuleGroupRuleStatementSizeConstraintStatementTextTransformation[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): Wafv2RuleGroupRuleStatementSizeConstraintStatementTextTransformationOutputReference;
}
export interface Wafv2RuleGroupRuleStatementSizeConstraintStatement {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#comparison_operator Wafv2RuleGroup#comparison_operator}
    */
    readonly comparisonOperator: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#size Wafv2RuleGroup#size}
    */
    readonly size: number;
    /**
    * field_to_match block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#field_to_match Wafv2RuleGroup#field_to_match}
    */
    readonly fieldToMatch?: Wafv2RuleGroupRuleStatementSizeConstraintStatementFieldToMatch;
    /**
    * text_transformation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#text_transformation Wafv2RuleGroup#text_transformation}
    */
    readonly textTransformation: Wafv2RuleGroupRuleStatementSizeConstraintStatementTextTransformation[] | cdktf.IResolvable;
}
export declare function wafv2RuleGroupRuleStatementSizeConstraintStatementToTerraform(struct?: Wafv2RuleGroupRuleStatementSizeConstraintStatementOutputReference | Wafv2RuleGroupRuleStatementSizeConstraintStatement): any;
export declare class Wafv2RuleGroupRuleStatementSizeConstraintStatementOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementSizeConstraintStatement | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementSizeConstraintStatement | undefined);
    private _comparisonOperator?;
    get comparisonOperator(): string;
    set comparisonOperator(value: string);
    get comparisonOperatorInput(): string | undefined;
    private _size?;
    get size(): number;
    set size(value: number);
    get sizeInput(): number | undefined;
    private _fieldToMatch;
    get fieldToMatch(): Wafv2RuleGroupRuleStatementSizeConstraintStatementFieldToMatchOutputReference;
    putFieldToMatch(value: Wafv2RuleGroupRuleStatementSizeConstraintStatementFieldToMatch): void;
    resetFieldToMatch(): void;
    get fieldToMatchInput(): Wafv2RuleGroupRuleStatementSizeConstraintStatementFieldToMatch | undefined;
    private _textTransformation;
    get textTransformation(): Wafv2RuleGroupRuleStatementSizeConstraintStatementTextTransformationList;
    putTextTransformation(value: Wafv2RuleGroupRuleStatementSizeConstraintStatementTextTransformation[] | cdktf.IResolvable): void;
    get textTransformationInput(): cdktf.IResolvable | Wafv2RuleGroupRuleStatementSizeConstraintStatementTextTransformation[] | undefined;
}
export interface Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchAllQueryArguments {
}
export declare function wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchAllQueryArgumentsToTerraform(struct?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchAllQueryArgumentsOutputReference | Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchAllQueryArguments): any;
export declare class Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchAllQueryArgumentsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchAllQueryArguments | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchAllQueryArguments | undefined);
}
export interface Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchBody {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#oversize_handling Wafv2RuleGroup#oversize_handling}
    */
    readonly oversizeHandling?: string;
}
export declare function wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchBodyToTerraform(struct?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchBodyOutputReference | Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchBody): any;
export declare class Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchBodyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchBody | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchBody | undefined);
    private _oversizeHandling?;
    get oversizeHandling(): string;
    set oversizeHandling(value: string);
    resetOversizeHandling(): void;
    get oversizeHandlingInput(): string | undefined;
}
export interface Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookiesMatchPatternAll {
}
export declare function wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookiesMatchPatternAllToTerraform(struct?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookiesMatchPatternAllOutputReference | Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookiesMatchPatternAll): any;
export declare class Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookiesMatchPatternAllOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookiesMatchPatternAll | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookiesMatchPatternAll | undefined);
}
export interface Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookiesMatchPattern {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#excluded_cookies Wafv2RuleGroup#excluded_cookies}
    */
    readonly excludedCookies?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#included_cookies Wafv2RuleGroup#included_cookies}
    */
    readonly includedCookies?: string[];
    /**
    * all block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#all Wafv2RuleGroup#all}
    */
    readonly all?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookiesMatchPatternAll;
}
export declare function wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookiesMatchPatternToTerraform(struct?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookiesMatchPattern | cdktf.IResolvable): any;
export declare class Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookiesMatchPatternOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookiesMatchPattern | cdktf.IResolvable | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookiesMatchPattern | cdktf.IResolvable | undefined);
    private _excludedCookies?;
    get excludedCookies(): string[];
    set excludedCookies(value: string[]);
    resetExcludedCookies(): void;
    get excludedCookiesInput(): string[] | undefined;
    private _includedCookies?;
    get includedCookies(): string[];
    set includedCookies(value: string[]);
    resetIncludedCookies(): void;
    get includedCookiesInput(): string[] | undefined;
    private _all;
    get all(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookiesMatchPatternAllOutputReference;
    putAll(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookiesMatchPatternAll): void;
    resetAll(): void;
    get allInput(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookiesMatchPatternAll | undefined;
}
export declare class Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookiesMatchPatternList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookiesMatchPattern[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookiesMatchPatternOutputReference;
}
export interface Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookies {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#match_scope Wafv2RuleGroup#match_scope}
    */
    readonly matchScope: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#oversize_handling Wafv2RuleGroup#oversize_handling}
    */
    readonly oversizeHandling: string;
    /**
    * match_pattern block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#match_pattern Wafv2RuleGroup#match_pattern}
    */
    readonly matchPattern: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookiesMatchPattern[] | cdktf.IResolvable;
}
export declare function wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookiesToTerraform(struct?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookiesOutputReference | Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookies): any;
export declare class Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookiesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookies | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookies | undefined);
    private _matchScope?;
    get matchScope(): string;
    set matchScope(value: string);
    get matchScopeInput(): string | undefined;
    private _oversizeHandling?;
    get oversizeHandling(): string;
    set oversizeHandling(value: string);
    get oversizeHandlingInput(): string | undefined;
    private _matchPattern;
    get matchPattern(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookiesMatchPatternList;
    putMatchPattern(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookiesMatchPattern[] | cdktf.IResolvable): void;
    get matchPatternInput(): cdktf.IResolvable | Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookiesMatchPattern[] | undefined;
}
export interface Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeadersMatchPatternAll {
}
export declare function wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeadersMatchPatternAllToTerraform(struct?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeadersMatchPatternAllOutputReference | Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeadersMatchPatternAll): any;
export declare class Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeadersMatchPatternAllOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeadersMatchPatternAll | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeadersMatchPatternAll | undefined);
}
export interface Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeadersMatchPattern {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#excluded_headers Wafv2RuleGroup#excluded_headers}
    */
    readonly excludedHeaders?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#included_headers Wafv2RuleGroup#included_headers}
    */
    readonly includedHeaders?: string[];
    /**
    * all block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#all Wafv2RuleGroup#all}
    */
    readonly all?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeadersMatchPatternAll;
}
export declare function wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeadersMatchPatternToTerraform(struct?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeadersMatchPatternOutputReference | Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeadersMatchPattern): any;
export declare class Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeadersMatchPatternOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeadersMatchPattern | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeadersMatchPattern | undefined);
    private _excludedHeaders?;
    get excludedHeaders(): string[];
    set excludedHeaders(value: string[]);
    resetExcludedHeaders(): void;
    get excludedHeadersInput(): string[] | undefined;
    private _includedHeaders?;
    get includedHeaders(): string[];
    set includedHeaders(value: string[]);
    resetIncludedHeaders(): void;
    get includedHeadersInput(): string[] | undefined;
    private _all;
    get all(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeadersMatchPatternAllOutputReference;
    putAll(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeadersMatchPatternAll): void;
    resetAll(): void;
    get allInput(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeadersMatchPatternAll | undefined;
}
export interface Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeaders {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#match_scope Wafv2RuleGroup#match_scope}
    */
    readonly matchScope: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#oversize_handling Wafv2RuleGroup#oversize_handling}
    */
    readonly oversizeHandling: string;
    /**
    * match_pattern block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#match_pattern Wafv2RuleGroup#match_pattern}
    */
    readonly matchPattern: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeadersMatchPattern;
}
export declare function wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeadersToTerraform(struct?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeaders | cdktf.IResolvable): any;
export declare class Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeadersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeaders | cdktf.IResolvable | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeaders | cdktf.IResolvable | undefined);
    private _matchScope?;
    get matchScope(): string;
    set matchScope(value: string);
    get matchScopeInput(): string | undefined;
    private _oversizeHandling?;
    get oversizeHandling(): string;
    set oversizeHandling(value: string);
    get oversizeHandlingInput(): string | undefined;
    private _matchPattern;
    get matchPattern(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeadersMatchPatternOutputReference;
    putMatchPattern(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeadersMatchPattern): void;
    get matchPatternInput(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeadersMatchPattern | undefined;
}
export declare class Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeadersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeaders[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeadersOutputReference;
}
export interface Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJa3Fingerprint {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#fallback_behavior Wafv2RuleGroup#fallback_behavior}
    */
    readonly fallbackBehavior: string;
}
export declare function wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJa3FingerprintToTerraform(struct?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJa3FingerprintOutputReference | Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJa3Fingerprint): any;
export declare class Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJa3FingerprintOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJa3Fingerprint | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJa3Fingerprint | undefined);
    private _fallbackBehavior?;
    get fallbackBehavior(): string;
    set fallbackBehavior(value: string);
    get fallbackBehaviorInput(): string | undefined;
}
export interface Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBodyMatchPatternAll {
}
export declare function wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBodyMatchPatternAllToTerraform(struct?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBodyMatchPatternAllOutputReference | Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBodyMatchPatternAll): any;
export declare class Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBodyMatchPatternAllOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBodyMatchPatternAll | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBodyMatchPatternAll | undefined);
}
export interface Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBodyMatchPattern {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#included_paths Wafv2RuleGroup#included_paths}
    */
    readonly includedPaths?: string[];
    /**
    * all block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#all Wafv2RuleGroup#all}
    */
    readonly all?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBodyMatchPatternAll;
}
export declare function wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBodyMatchPatternToTerraform(struct?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBodyMatchPatternOutputReference | Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBodyMatchPattern): any;
export declare class Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBodyMatchPatternOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBodyMatchPattern | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBodyMatchPattern | undefined);
    private _includedPaths?;
    get includedPaths(): string[];
    set includedPaths(value: string[]);
    resetIncludedPaths(): void;
    get includedPathsInput(): string[] | undefined;
    private _all;
    get all(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBodyMatchPatternAllOutputReference;
    putAll(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBodyMatchPatternAll): void;
    resetAll(): void;
    get allInput(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBodyMatchPatternAll | undefined;
}
export interface Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBody {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#invalid_fallback_behavior Wafv2RuleGroup#invalid_fallback_behavior}
    */
    readonly invalidFallbackBehavior?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#match_scope Wafv2RuleGroup#match_scope}
    */
    readonly matchScope: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#oversize_handling Wafv2RuleGroup#oversize_handling}
    */
    readonly oversizeHandling?: string;
    /**
    * match_pattern block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#match_pattern Wafv2RuleGroup#match_pattern}
    */
    readonly matchPattern: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBodyMatchPattern;
}
export declare function wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBodyToTerraform(struct?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBodyOutputReference | Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBody): any;
export declare class Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBodyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBody | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBody | undefined);
    private _invalidFallbackBehavior?;
    get invalidFallbackBehavior(): string;
    set invalidFallbackBehavior(value: string);
    resetInvalidFallbackBehavior(): void;
    get invalidFallbackBehaviorInput(): string | undefined;
    private _matchScope?;
    get matchScope(): string;
    set matchScope(value: string);
    get matchScopeInput(): string | undefined;
    private _oversizeHandling?;
    get oversizeHandling(): string;
    set oversizeHandling(value: string);
    resetOversizeHandling(): void;
    get oversizeHandlingInput(): string | undefined;
    private _matchPattern;
    get matchPattern(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBodyMatchPatternOutputReference;
    putMatchPattern(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBodyMatchPattern): void;
    get matchPatternInput(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBodyMatchPattern | undefined;
}
export interface Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchMethod {
}
export declare function wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchMethodToTerraform(struct?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchMethodOutputReference | Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchMethod): any;
export declare class Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchMethodOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchMethod | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchMethod | undefined);
}
export interface Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchQueryString {
}
export declare function wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchQueryStringToTerraform(struct?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchQueryStringOutputReference | Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchQueryString): any;
export declare class Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchQueryStringOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchQueryString | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchQueryString | undefined);
}
export interface Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchSingleHeader {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#name Wafv2RuleGroup#name}
    */
    readonly name: string;
}
export declare function wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchSingleHeaderToTerraform(struct?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchSingleHeaderOutputReference | Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchSingleHeader): any;
export declare class Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchSingleHeaderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchSingleHeader | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchSingleHeader | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
}
export interface Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchSingleQueryArgument {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#name Wafv2RuleGroup#name}
    */
    readonly name: string;
}
export declare function wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchSingleQueryArgumentToTerraform(struct?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchSingleQueryArgumentOutputReference | Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchSingleQueryArgument): any;
export declare class Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchSingleQueryArgumentOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchSingleQueryArgument | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchSingleQueryArgument | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
}
export interface Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchUriPath {
}
export declare function wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchUriPathToTerraform(struct?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchUriPathOutputReference | Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchUriPath): any;
export declare class Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchUriPathOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchUriPath | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchUriPath | undefined);
}
export interface Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatch {
    /**
    * all_query_arguments block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#all_query_arguments Wafv2RuleGroup#all_query_arguments}
    */
    readonly allQueryArguments?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchAllQueryArguments;
    /**
    * body block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#body Wafv2RuleGroup#body}
    */
    readonly body?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchBody;
    /**
    * cookies block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#cookies Wafv2RuleGroup#cookies}
    */
    readonly cookies?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookies;
    /**
    * headers block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#headers Wafv2RuleGroup#headers}
    */
    readonly headers?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeaders[] | cdktf.IResolvable;
    /**
    * ja3_fingerprint block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#ja3_fingerprint Wafv2RuleGroup#ja3_fingerprint}
    */
    readonly ja3Fingerprint?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJa3Fingerprint;
    /**
    * json_body block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#json_body Wafv2RuleGroup#json_body}
    */
    readonly jsonBody?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBody;
    /**
    * method block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#method Wafv2RuleGroup#method}
    */
    readonly method?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchMethod;
    /**
    * query_string block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#query_string Wafv2RuleGroup#query_string}
    */
    readonly queryString?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchQueryString;
    /**
    * single_header block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#single_header Wafv2RuleGroup#single_header}
    */
    readonly singleHeader?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchSingleHeader;
    /**
    * single_query_argument block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#single_query_argument Wafv2RuleGroup#single_query_argument}
    */
    readonly singleQueryArgument?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchSingleQueryArgument;
    /**
    * uri_path block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#uri_path Wafv2RuleGroup#uri_path}
    */
    readonly uriPath?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchUriPath;
}
export declare function wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchToTerraform(struct?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchOutputReference | Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatch): any;
export declare class Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatch | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatch | undefined);
    private _allQueryArguments;
    get allQueryArguments(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchAllQueryArgumentsOutputReference;
    putAllQueryArguments(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchAllQueryArguments): void;
    resetAllQueryArguments(): void;
    get allQueryArgumentsInput(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchAllQueryArguments | undefined;
    private _body;
    get body(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchBodyOutputReference;
    putBody(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchBody): void;
    resetBody(): void;
    get bodyInput(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchBody | undefined;
    private _cookies;
    get cookies(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookiesOutputReference;
    putCookies(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookies): void;
    resetCookies(): void;
    get cookiesInput(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchCookies | undefined;
    private _headers;
    get headers(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeadersList;
    putHeaders(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeaders[] | cdktf.IResolvable): void;
    resetHeaders(): void;
    get headersInput(): cdktf.IResolvable | Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchHeaders[] | undefined;
    private _ja3Fingerprint;
    get ja3Fingerprint(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJa3FingerprintOutputReference;
    putJa3Fingerprint(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJa3Fingerprint): void;
    resetJa3Fingerprint(): void;
    get ja3FingerprintInput(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJa3Fingerprint | undefined;
    private _jsonBody;
    get jsonBody(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBodyOutputReference;
    putJsonBody(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBody): void;
    resetJsonBody(): void;
    get jsonBodyInput(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchJsonBody | undefined;
    private _method;
    get method(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchMethodOutputReference;
    putMethod(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchMethod): void;
    resetMethod(): void;
    get methodInput(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchMethod | undefined;
    private _queryString;
    get queryString(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchQueryStringOutputReference;
    putQueryString(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchQueryString): void;
    resetQueryString(): void;
    get queryStringInput(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchQueryString | undefined;
    private _singleHeader;
    get singleHeader(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchSingleHeaderOutputReference;
    putSingleHeader(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchSingleHeader): void;
    resetSingleHeader(): void;
    get singleHeaderInput(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchSingleHeader | undefined;
    private _singleQueryArgument;
    get singleQueryArgument(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchSingleQueryArgumentOutputReference;
    putSingleQueryArgument(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchSingleQueryArgument): void;
    resetSingleQueryArgument(): void;
    get singleQueryArgumentInput(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchSingleQueryArgument | undefined;
    private _uriPath;
    get uriPath(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchUriPathOutputReference;
    putUriPath(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchUriPath): void;
    resetUriPath(): void;
    get uriPathInput(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchUriPath | undefined;
}
export interface Wafv2RuleGroupRuleStatementSqliMatchStatementTextTransformation {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#priority Wafv2RuleGroup#priority}
    */
    readonly priority: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#type Wafv2RuleGroup#type}
    */
    readonly type: string;
}
export declare function wafv2RuleGroupRuleStatementSqliMatchStatementTextTransformationToTerraform(struct?: Wafv2RuleGroupRuleStatementSqliMatchStatementTextTransformation | cdktf.IResolvable): any;
export declare class Wafv2RuleGroupRuleStatementSqliMatchStatementTextTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): Wafv2RuleGroupRuleStatementSqliMatchStatementTextTransformation | cdktf.IResolvable | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementSqliMatchStatementTextTransformation | cdktf.IResolvable | undefined);
    private _priority?;
    get priority(): number;
    set priority(value: number);
    get priorityInput(): number | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
}
export declare class Wafv2RuleGroupRuleStatementSqliMatchStatementTextTransformationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: Wafv2RuleGroupRuleStatementSqliMatchStatementTextTransformation[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): Wafv2RuleGroupRuleStatementSqliMatchStatementTextTransformationOutputReference;
}
export interface Wafv2RuleGroupRuleStatementSqliMatchStatement {
    /**
    * field_to_match block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#field_to_match Wafv2RuleGroup#field_to_match}
    */
    readonly fieldToMatch?: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatch;
    /**
    * text_transformation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#text_transformation Wafv2RuleGroup#text_transformation}
    */
    readonly textTransformation: Wafv2RuleGroupRuleStatementSqliMatchStatementTextTransformation[] | cdktf.IResolvable;
}
export declare function wafv2RuleGroupRuleStatementSqliMatchStatementToTerraform(struct?: Wafv2RuleGroupRuleStatementSqliMatchStatementOutputReference | Wafv2RuleGroupRuleStatementSqliMatchStatement): any;
export declare class Wafv2RuleGroupRuleStatementSqliMatchStatementOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementSqliMatchStatement | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementSqliMatchStatement | undefined);
    private _fieldToMatch;
    get fieldToMatch(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatchOutputReference;
    putFieldToMatch(value: Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatch): void;
    resetFieldToMatch(): void;
    get fieldToMatchInput(): Wafv2RuleGroupRuleStatementSqliMatchStatementFieldToMatch | undefined;
    private _textTransformation;
    get textTransformation(): Wafv2RuleGroupRuleStatementSqliMatchStatementTextTransformationList;
    putTextTransformation(value: Wafv2RuleGroupRuleStatementSqliMatchStatementTextTransformation[] | cdktf.IResolvable): void;
    get textTransformationInput(): cdktf.IResolvable | Wafv2RuleGroupRuleStatementSqliMatchStatementTextTransformation[] | undefined;
}
export interface Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchAllQueryArguments {
}
export declare function wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchAllQueryArgumentsToTerraform(struct?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchAllQueryArgumentsOutputReference | Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchAllQueryArguments): any;
export declare class Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchAllQueryArgumentsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchAllQueryArguments | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchAllQueryArguments | undefined);
}
export interface Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchBody {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#oversize_handling Wafv2RuleGroup#oversize_handling}
    */
    readonly oversizeHandling?: string;
}
export declare function wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchBodyToTerraform(struct?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchBodyOutputReference | Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchBody): any;
export declare class Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchBodyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchBody | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchBody | undefined);
    private _oversizeHandling?;
    get oversizeHandling(): string;
    set oversizeHandling(value: string);
    resetOversizeHandling(): void;
    get oversizeHandlingInput(): string | undefined;
}
export interface Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookiesMatchPatternAll {
}
export declare function wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookiesMatchPatternAllToTerraform(struct?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookiesMatchPatternAllOutputReference | Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookiesMatchPatternAll): any;
export declare class Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookiesMatchPatternAllOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookiesMatchPatternAll | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookiesMatchPatternAll | undefined);
}
export interface Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookiesMatchPattern {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#excluded_cookies Wafv2RuleGroup#excluded_cookies}
    */
    readonly excludedCookies?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#included_cookies Wafv2RuleGroup#included_cookies}
    */
    readonly includedCookies?: string[];
    /**
    * all block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#all Wafv2RuleGroup#all}
    */
    readonly all?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookiesMatchPatternAll;
}
export declare function wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookiesMatchPatternToTerraform(struct?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookiesMatchPattern | cdktf.IResolvable): any;
export declare class Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookiesMatchPatternOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookiesMatchPattern | cdktf.IResolvable | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookiesMatchPattern | cdktf.IResolvable | undefined);
    private _excludedCookies?;
    get excludedCookies(): string[];
    set excludedCookies(value: string[]);
    resetExcludedCookies(): void;
    get excludedCookiesInput(): string[] | undefined;
    private _includedCookies?;
    get includedCookies(): string[];
    set includedCookies(value: string[]);
    resetIncludedCookies(): void;
    get includedCookiesInput(): string[] | undefined;
    private _all;
    get all(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookiesMatchPatternAllOutputReference;
    putAll(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookiesMatchPatternAll): void;
    resetAll(): void;
    get allInput(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookiesMatchPatternAll | undefined;
}
export declare class Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookiesMatchPatternList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookiesMatchPattern[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookiesMatchPatternOutputReference;
}
export interface Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookies {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#match_scope Wafv2RuleGroup#match_scope}
    */
    readonly matchScope: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#oversize_handling Wafv2RuleGroup#oversize_handling}
    */
    readonly oversizeHandling: string;
    /**
    * match_pattern block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#match_pattern Wafv2RuleGroup#match_pattern}
    */
    readonly matchPattern: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookiesMatchPattern[] | cdktf.IResolvable;
}
export declare function wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookiesToTerraform(struct?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookiesOutputReference | Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookies): any;
export declare class Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookiesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookies | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookies | undefined);
    private _matchScope?;
    get matchScope(): string;
    set matchScope(value: string);
    get matchScopeInput(): string | undefined;
    private _oversizeHandling?;
    get oversizeHandling(): string;
    set oversizeHandling(value: string);
    get oversizeHandlingInput(): string | undefined;
    private _matchPattern;
    get matchPattern(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookiesMatchPatternList;
    putMatchPattern(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookiesMatchPattern[] | cdktf.IResolvable): void;
    get matchPatternInput(): cdktf.IResolvable | Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookiesMatchPattern[] | undefined;
}
export interface Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeadersMatchPatternAll {
}
export declare function wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeadersMatchPatternAllToTerraform(struct?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeadersMatchPatternAllOutputReference | Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeadersMatchPatternAll): any;
export declare class Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeadersMatchPatternAllOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeadersMatchPatternAll | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeadersMatchPatternAll | undefined);
}
export interface Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeadersMatchPattern {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#excluded_headers Wafv2RuleGroup#excluded_headers}
    */
    readonly excludedHeaders?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#included_headers Wafv2RuleGroup#included_headers}
    */
    readonly includedHeaders?: string[];
    /**
    * all block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#all Wafv2RuleGroup#all}
    */
    readonly all?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeadersMatchPatternAll;
}
export declare function wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeadersMatchPatternToTerraform(struct?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeadersMatchPatternOutputReference | Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeadersMatchPattern): any;
export declare class Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeadersMatchPatternOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeadersMatchPattern | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeadersMatchPattern | undefined);
    private _excludedHeaders?;
    get excludedHeaders(): string[];
    set excludedHeaders(value: string[]);
    resetExcludedHeaders(): void;
    get excludedHeadersInput(): string[] | undefined;
    private _includedHeaders?;
    get includedHeaders(): string[];
    set includedHeaders(value: string[]);
    resetIncludedHeaders(): void;
    get includedHeadersInput(): string[] | undefined;
    private _all;
    get all(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeadersMatchPatternAllOutputReference;
    putAll(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeadersMatchPatternAll): void;
    resetAll(): void;
    get allInput(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeadersMatchPatternAll | undefined;
}
export interface Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeaders {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#match_scope Wafv2RuleGroup#match_scope}
    */
    readonly matchScope: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#oversize_handling Wafv2RuleGroup#oversize_handling}
    */
    readonly oversizeHandling: string;
    /**
    * match_pattern block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#match_pattern Wafv2RuleGroup#match_pattern}
    */
    readonly matchPattern: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeadersMatchPattern;
}
export declare function wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeadersToTerraform(struct?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeaders | cdktf.IResolvable): any;
export declare class Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeadersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeaders | cdktf.IResolvable | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeaders | cdktf.IResolvable | undefined);
    private _matchScope?;
    get matchScope(): string;
    set matchScope(value: string);
    get matchScopeInput(): string | undefined;
    private _oversizeHandling?;
    get oversizeHandling(): string;
    set oversizeHandling(value: string);
    get oversizeHandlingInput(): string | undefined;
    private _matchPattern;
    get matchPattern(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeadersMatchPatternOutputReference;
    putMatchPattern(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeadersMatchPattern): void;
    get matchPatternInput(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeadersMatchPattern | undefined;
}
export declare class Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeadersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeaders[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeadersOutputReference;
}
export interface Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJa3Fingerprint {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#fallback_behavior Wafv2RuleGroup#fallback_behavior}
    */
    readonly fallbackBehavior: string;
}
export declare function wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJa3FingerprintToTerraform(struct?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJa3FingerprintOutputReference | Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJa3Fingerprint): any;
export declare class Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJa3FingerprintOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJa3Fingerprint | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJa3Fingerprint | undefined);
    private _fallbackBehavior?;
    get fallbackBehavior(): string;
    set fallbackBehavior(value: string);
    get fallbackBehaviorInput(): string | undefined;
}
export interface Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBodyMatchPatternAll {
}
export declare function wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBodyMatchPatternAllToTerraform(struct?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBodyMatchPatternAllOutputReference | Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBodyMatchPatternAll): any;
export declare class Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBodyMatchPatternAllOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBodyMatchPatternAll | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBodyMatchPatternAll | undefined);
}
export interface Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBodyMatchPattern {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#included_paths Wafv2RuleGroup#included_paths}
    */
    readonly includedPaths?: string[];
    /**
    * all block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#all Wafv2RuleGroup#all}
    */
    readonly all?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBodyMatchPatternAll;
}
export declare function wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBodyMatchPatternToTerraform(struct?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBodyMatchPatternOutputReference | Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBodyMatchPattern): any;
export declare class Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBodyMatchPatternOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBodyMatchPattern | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBodyMatchPattern | undefined);
    private _includedPaths?;
    get includedPaths(): string[];
    set includedPaths(value: string[]);
    resetIncludedPaths(): void;
    get includedPathsInput(): string[] | undefined;
    private _all;
    get all(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBodyMatchPatternAllOutputReference;
    putAll(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBodyMatchPatternAll): void;
    resetAll(): void;
    get allInput(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBodyMatchPatternAll | undefined;
}
export interface Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBody {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#invalid_fallback_behavior Wafv2RuleGroup#invalid_fallback_behavior}
    */
    readonly invalidFallbackBehavior?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#match_scope Wafv2RuleGroup#match_scope}
    */
    readonly matchScope: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#oversize_handling Wafv2RuleGroup#oversize_handling}
    */
    readonly oversizeHandling?: string;
    /**
    * match_pattern block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#match_pattern Wafv2RuleGroup#match_pattern}
    */
    readonly matchPattern: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBodyMatchPattern;
}
export declare function wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBodyToTerraform(struct?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBodyOutputReference | Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBody): any;
export declare class Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBodyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBody | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBody | undefined);
    private _invalidFallbackBehavior?;
    get invalidFallbackBehavior(): string;
    set invalidFallbackBehavior(value: string);
    resetInvalidFallbackBehavior(): void;
    get invalidFallbackBehaviorInput(): string | undefined;
    private _matchScope?;
    get matchScope(): string;
    set matchScope(value: string);
    get matchScopeInput(): string | undefined;
    private _oversizeHandling?;
    get oversizeHandling(): string;
    set oversizeHandling(value: string);
    resetOversizeHandling(): void;
    get oversizeHandlingInput(): string | undefined;
    private _matchPattern;
    get matchPattern(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBodyMatchPatternOutputReference;
    putMatchPattern(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBodyMatchPattern): void;
    get matchPatternInput(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBodyMatchPattern | undefined;
}
export interface Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchMethod {
}
export declare function wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchMethodToTerraform(struct?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchMethodOutputReference | Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchMethod): any;
export declare class Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchMethodOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchMethod | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchMethod | undefined);
}
export interface Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchQueryString {
}
export declare function wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchQueryStringToTerraform(struct?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchQueryStringOutputReference | Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchQueryString): any;
export declare class Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchQueryStringOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchQueryString | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchQueryString | undefined);
}
export interface Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchSingleHeader {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#name Wafv2RuleGroup#name}
    */
    readonly name: string;
}
export declare function wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchSingleHeaderToTerraform(struct?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchSingleHeaderOutputReference | Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchSingleHeader): any;
export declare class Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchSingleHeaderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchSingleHeader | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchSingleHeader | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
}
export interface Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchSingleQueryArgument {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#name Wafv2RuleGroup#name}
    */
    readonly name: string;
}
export declare function wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchSingleQueryArgumentToTerraform(struct?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchSingleQueryArgumentOutputReference | Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchSingleQueryArgument): any;
export declare class Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchSingleQueryArgumentOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchSingleQueryArgument | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchSingleQueryArgument | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
}
export interface Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchUriPath {
}
export declare function wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchUriPathToTerraform(struct?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchUriPathOutputReference | Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchUriPath): any;
export declare class Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchUriPathOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchUriPath | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchUriPath | undefined);
}
export interface Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatch {
    /**
    * all_query_arguments block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#all_query_arguments Wafv2RuleGroup#all_query_arguments}
    */
    readonly allQueryArguments?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchAllQueryArguments;
    /**
    * body block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#body Wafv2RuleGroup#body}
    */
    readonly body?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchBody;
    /**
    * cookies block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#cookies Wafv2RuleGroup#cookies}
    */
    readonly cookies?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookies;
    /**
    * headers block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#headers Wafv2RuleGroup#headers}
    */
    readonly headers?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeaders[] | cdktf.IResolvable;
    /**
    * ja3_fingerprint block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#ja3_fingerprint Wafv2RuleGroup#ja3_fingerprint}
    */
    readonly ja3Fingerprint?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJa3Fingerprint;
    /**
    * json_body block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#json_body Wafv2RuleGroup#json_body}
    */
    readonly jsonBody?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBody;
    /**
    * method block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#method Wafv2RuleGroup#method}
    */
    readonly method?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchMethod;
    /**
    * query_string block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#query_string Wafv2RuleGroup#query_string}
    */
    readonly queryString?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchQueryString;
    /**
    * single_header block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#single_header Wafv2RuleGroup#single_header}
    */
    readonly singleHeader?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchSingleHeader;
    /**
    * single_query_argument block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#single_query_argument Wafv2RuleGroup#single_query_argument}
    */
    readonly singleQueryArgument?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchSingleQueryArgument;
    /**
    * uri_path block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#uri_path Wafv2RuleGroup#uri_path}
    */
    readonly uriPath?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchUriPath;
}
export declare function wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchToTerraform(struct?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchOutputReference | Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatch): any;
export declare class Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatch | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatch | undefined);
    private _allQueryArguments;
    get allQueryArguments(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchAllQueryArgumentsOutputReference;
    putAllQueryArguments(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchAllQueryArguments): void;
    resetAllQueryArguments(): void;
    get allQueryArgumentsInput(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchAllQueryArguments | undefined;
    private _body;
    get body(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchBodyOutputReference;
    putBody(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchBody): void;
    resetBody(): void;
    get bodyInput(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchBody | undefined;
    private _cookies;
    get cookies(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookiesOutputReference;
    putCookies(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookies): void;
    resetCookies(): void;
    get cookiesInput(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchCookies | undefined;
    private _headers;
    get headers(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeadersList;
    putHeaders(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeaders[] | cdktf.IResolvable): void;
    resetHeaders(): void;
    get headersInput(): cdktf.IResolvable | Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchHeaders[] | undefined;
    private _ja3Fingerprint;
    get ja3Fingerprint(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJa3FingerprintOutputReference;
    putJa3Fingerprint(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJa3Fingerprint): void;
    resetJa3Fingerprint(): void;
    get ja3FingerprintInput(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJa3Fingerprint | undefined;
    private _jsonBody;
    get jsonBody(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBodyOutputReference;
    putJsonBody(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBody): void;
    resetJsonBody(): void;
    get jsonBodyInput(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchJsonBody | undefined;
    private _method;
    get method(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchMethodOutputReference;
    putMethod(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchMethod): void;
    resetMethod(): void;
    get methodInput(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchMethod | undefined;
    private _queryString;
    get queryString(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchQueryStringOutputReference;
    putQueryString(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchQueryString): void;
    resetQueryString(): void;
    get queryStringInput(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchQueryString | undefined;
    private _singleHeader;
    get singleHeader(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchSingleHeaderOutputReference;
    putSingleHeader(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchSingleHeader): void;
    resetSingleHeader(): void;
    get singleHeaderInput(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchSingleHeader | undefined;
    private _singleQueryArgument;
    get singleQueryArgument(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchSingleQueryArgumentOutputReference;
    putSingleQueryArgument(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchSingleQueryArgument): void;
    resetSingleQueryArgument(): void;
    get singleQueryArgumentInput(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchSingleQueryArgument | undefined;
    private _uriPath;
    get uriPath(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchUriPathOutputReference;
    putUriPath(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchUriPath): void;
    resetUriPath(): void;
    get uriPathInput(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchUriPath | undefined;
}
export interface Wafv2RuleGroupRuleStatementXssMatchStatementTextTransformation {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#priority Wafv2RuleGroup#priority}
    */
    readonly priority: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#type Wafv2RuleGroup#type}
    */
    readonly type: string;
}
export declare function wafv2RuleGroupRuleStatementXssMatchStatementTextTransformationToTerraform(struct?: Wafv2RuleGroupRuleStatementXssMatchStatementTextTransformation | cdktf.IResolvable): any;
export declare class Wafv2RuleGroupRuleStatementXssMatchStatementTextTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): Wafv2RuleGroupRuleStatementXssMatchStatementTextTransformation | cdktf.IResolvable | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementXssMatchStatementTextTransformation | cdktf.IResolvable | undefined);
    private _priority?;
    get priority(): number;
    set priority(value: number);
    get priorityInput(): number | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
}
export declare class Wafv2RuleGroupRuleStatementXssMatchStatementTextTransformationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: Wafv2RuleGroupRuleStatementXssMatchStatementTextTransformation[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): Wafv2RuleGroupRuleStatementXssMatchStatementTextTransformationOutputReference;
}
export interface Wafv2RuleGroupRuleStatementXssMatchStatement {
    /**
    * field_to_match block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#field_to_match Wafv2RuleGroup#field_to_match}
    */
    readonly fieldToMatch?: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatch;
    /**
    * text_transformation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#text_transformation Wafv2RuleGroup#text_transformation}
    */
    readonly textTransformation: Wafv2RuleGroupRuleStatementXssMatchStatementTextTransformation[] | cdktf.IResolvable;
}
export declare function wafv2RuleGroupRuleStatementXssMatchStatementToTerraform(struct?: Wafv2RuleGroupRuleStatementXssMatchStatementOutputReference | Wafv2RuleGroupRuleStatementXssMatchStatement): any;
export declare class Wafv2RuleGroupRuleStatementXssMatchStatementOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatementXssMatchStatement | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatementXssMatchStatement | undefined);
    private _fieldToMatch;
    get fieldToMatch(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatchOutputReference;
    putFieldToMatch(value: Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatch): void;
    resetFieldToMatch(): void;
    get fieldToMatchInput(): Wafv2RuleGroupRuleStatementXssMatchStatementFieldToMatch | undefined;
    private _textTransformation;
    get textTransformation(): Wafv2RuleGroupRuleStatementXssMatchStatementTextTransformationList;
    putTextTransformation(value: Wafv2RuleGroupRuleStatementXssMatchStatementTextTransformation[] | cdktf.IResolvable): void;
    get textTransformationInput(): cdktf.IResolvable | Wafv2RuleGroupRuleStatementXssMatchStatementTextTransformation[] | undefined;
}
export interface Wafv2RuleGroupRuleStatement {
    /**
    * and_statement block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#and_statement Wafv2RuleGroup#and_statement}
    */
    readonly andStatement?: Wafv2RuleGroupRuleStatementAndStatement;
    /**
    * byte_match_statement block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#byte_match_statement Wafv2RuleGroup#byte_match_statement}
    */
    readonly byteMatchStatement?: Wafv2RuleGroupRuleStatementByteMatchStatement;
    /**
    * geo_match_statement block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#geo_match_statement Wafv2RuleGroup#geo_match_statement}
    */
    readonly geoMatchStatement?: Wafv2RuleGroupRuleStatementGeoMatchStatement;
    /**
    * ip_set_reference_statement block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#ip_set_reference_statement Wafv2RuleGroup#ip_set_reference_statement}
    */
    readonly ipSetReferenceStatement?: Wafv2RuleGroupRuleStatementIpSetReferenceStatement;
    /**
    * label_match_statement block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#label_match_statement Wafv2RuleGroup#label_match_statement}
    */
    readonly labelMatchStatement?: Wafv2RuleGroupRuleStatementLabelMatchStatement;
    /**
    * not_statement block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#not_statement Wafv2RuleGroup#not_statement}
    */
    readonly notStatement?: Wafv2RuleGroupRuleStatementNotStatement;
    /**
    * or_statement block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#or_statement Wafv2RuleGroup#or_statement}
    */
    readonly orStatement?: Wafv2RuleGroupRuleStatementOrStatement;
    /**
    * rate_based_statement block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#rate_based_statement Wafv2RuleGroup#rate_based_statement}
    */
    readonly rateBasedStatement?: Wafv2RuleGroupRuleStatementRateBasedStatement;
    /**
    * regex_match_statement block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#regex_match_statement Wafv2RuleGroup#regex_match_statement}
    */
    readonly regexMatchStatement?: Wafv2RuleGroupRuleStatementRegexMatchStatement;
    /**
    * regex_pattern_set_reference_statement block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#regex_pattern_set_reference_statement Wafv2RuleGroup#regex_pattern_set_reference_statement}
    */
    readonly regexPatternSetReferenceStatement?: Wafv2RuleGroupRuleStatementRegexPatternSetReferenceStatement;
    /**
    * size_constraint_statement block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#size_constraint_statement Wafv2RuleGroup#size_constraint_statement}
    */
    readonly sizeConstraintStatement?: Wafv2RuleGroupRuleStatementSizeConstraintStatement;
    /**
    * sqli_match_statement block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#sqli_match_statement Wafv2RuleGroup#sqli_match_statement}
    */
    readonly sqliMatchStatement?: Wafv2RuleGroupRuleStatementSqliMatchStatement;
    /**
    * xss_match_statement block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#xss_match_statement Wafv2RuleGroup#xss_match_statement}
    */
    readonly xssMatchStatement?: Wafv2RuleGroupRuleStatementXssMatchStatement;
}
export declare function wafv2RuleGroupRuleStatementToTerraform(struct?: Wafv2RuleGroupRuleStatementOutputReference | Wafv2RuleGroupRuleStatement): any;
export declare class Wafv2RuleGroupRuleStatementOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleStatement | undefined;
    set internalValue(value: Wafv2RuleGroupRuleStatement | undefined);
    private _andStatement;
    get andStatement(): Wafv2RuleGroupRuleStatementAndStatementOutputReference;
    putAndStatement(value: Wafv2RuleGroupRuleStatementAndStatement): void;
    resetAndStatement(): void;
    get andStatementInput(): Wafv2RuleGroupRuleStatementAndStatement | undefined;
    private _byteMatchStatement;
    get byteMatchStatement(): Wafv2RuleGroupRuleStatementByteMatchStatementOutputReference;
    putByteMatchStatement(value: Wafv2RuleGroupRuleStatementByteMatchStatement): void;
    resetByteMatchStatement(): void;
    get byteMatchStatementInput(): Wafv2RuleGroupRuleStatementByteMatchStatement | undefined;
    private _geoMatchStatement;
    get geoMatchStatement(): Wafv2RuleGroupRuleStatementGeoMatchStatementOutputReference;
    putGeoMatchStatement(value: Wafv2RuleGroupRuleStatementGeoMatchStatement): void;
    resetGeoMatchStatement(): void;
    get geoMatchStatementInput(): Wafv2RuleGroupRuleStatementGeoMatchStatement | undefined;
    private _ipSetReferenceStatement;
    get ipSetReferenceStatement(): Wafv2RuleGroupRuleStatementIpSetReferenceStatementOutputReference;
    putIpSetReferenceStatement(value: Wafv2RuleGroupRuleStatementIpSetReferenceStatement): void;
    resetIpSetReferenceStatement(): void;
    get ipSetReferenceStatementInput(): Wafv2RuleGroupRuleStatementIpSetReferenceStatement | undefined;
    private _labelMatchStatement;
    get labelMatchStatement(): Wafv2RuleGroupRuleStatementLabelMatchStatementOutputReference;
    putLabelMatchStatement(value: Wafv2RuleGroupRuleStatementLabelMatchStatement): void;
    resetLabelMatchStatement(): void;
    get labelMatchStatementInput(): Wafv2RuleGroupRuleStatementLabelMatchStatement | undefined;
    private _notStatement;
    get notStatement(): Wafv2RuleGroupRuleStatementNotStatementOutputReference;
    putNotStatement(value: Wafv2RuleGroupRuleStatementNotStatement): void;
    resetNotStatement(): void;
    get notStatementInput(): Wafv2RuleGroupRuleStatementNotStatement | undefined;
    private _orStatement;
    get orStatement(): Wafv2RuleGroupRuleStatementOrStatementOutputReference;
    putOrStatement(value: Wafv2RuleGroupRuleStatementOrStatement): void;
    resetOrStatement(): void;
    get orStatementInput(): Wafv2RuleGroupRuleStatementOrStatement | undefined;
    private _rateBasedStatement;
    get rateBasedStatement(): Wafv2RuleGroupRuleStatementRateBasedStatementOutputReference;
    putRateBasedStatement(value: Wafv2RuleGroupRuleStatementRateBasedStatement): void;
    resetRateBasedStatement(): void;
    get rateBasedStatementInput(): Wafv2RuleGroupRuleStatementRateBasedStatement | undefined;
    private _regexMatchStatement;
    get regexMatchStatement(): Wafv2RuleGroupRuleStatementRegexMatchStatementOutputReference;
    putRegexMatchStatement(value: Wafv2RuleGroupRuleStatementRegexMatchStatement): void;
    resetRegexMatchStatement(): void;
    get regexMatchStatementInput(): Wafv2RuleGroupRuleStatementRegexMatchStatement | undefined;
    private _regexPatternSetReferenceStatement;
    get regexPatternSetReferenceStatement(): Wafv2RuleGroupRuleStatementRegexPatternSetReferenceStatementOutputReference;
    putRegexPatternSetReferenceStatement(value: Wafv2RuleGroupRuleStatementRegexPatternSetReferenceStatement): void;
    resetRegexPatternSetReferenceStatement(): void;
    get regexPatternSetReferenceStatementInput(): Wafv2RuleGroupRuleStatementRegexPatternSetReferenceStatement | undefined;
    private _sizeConstraintStatement;
    get sizeConstraintStatement(): Wafv2RuleGroupRuleStatementSizeConstraintStatementOutputReference;
    putSizeConstraintStatement(value: Wafv2RuleGroupRuleStatementSizeConstraintStatement): void;
    resetSizeConstraintStatement(): void;
    get sizeConstraintStatementInput(): Wafv2RuleGroupRuleStatementSizeConstraintStatement | undefined;
    private _sqliMatchStatement;
    get sqliMatchStatement(): Wafv2RuleGroupRuleStatementSqliMatchStatementOutputReference;
    putSqliMatchStatement(value: Wafv2RuleGroupRuleStatementSqliMatchStatement): void;
    resetSqliMatchStatement(): void;
    get sqliMatchStatementInput(): Wafv2RuleGroupRuleStatementSqliMatchStatement | undefined;
    private _xssMatchStatement;
    get xssMatchStatement(): Wafv2RuleGroupRuleStatementXssMatchStatementOutputReference;
    putXssMatchStatement(value: Wafv2RuleGroupRuleStatementXssMatchStatement): void;
    resetXssMatchStatement(): void;
    get xssMatchStatementInput(): Wafv2RuleGroupRuleStatementXssMatchStatement | undefined;
}
export interface Wafv2RuleGroupRuleVisibilityConfig {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#cloudwatch_metrics_enabled Wafv2RuleGroup#cloudwatch_metrics_enabled}
    */
    readonly cloudwatchMetricsEnabled: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#metric_name Wafv2RuleGroup#metric_name}
    */
    readonly metricName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#sampled_requests_enabled Wafv2RuleGroup#sampled_requests_enabled}
    */
    readonly sampledRequestsEnabled: boolean | cdktf.IResolvable;
}
export declare function wafv2RuleGroupRuleVisibilityConfigToTerraform(struct?: Wafv2RuleGroupRuleVisibilityConfigOutputReference | Wafv2RuleGroupRuleVisibilityConfig): any;
export declare class Wafv2RuleGroupRuleVisibilityConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupRuleVisibilityConfig | undefined;
    set internalValue(value: Wafv2RuleGroupRuleVisibilityConfig | undefined);
    private _cloudwatchMetricsEnabled?;
    get cloudwatchMetricsEnabled(): boolean | cdktf.IResolvable;
    set cloudwatchMetricsEnabled(value: boolean | cdktf.IResolvable);
    get cloudwatchMetricsEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _metricName?;
    get metricName(): string;
    set metricName(value: string);
    get metricNameInput(): string | undefined;
    private _sampledRequestsEnabled?;
    get sampledRequestsEnabled(): boolean | cdktf.IResolvable;
    set sampledRequestsEnabled(value: boolean | cdktf.IResolvable);
    get sampledRequestsEnabledInput(): boolean | cdktf.IResolvable | undefined;
}
export interface Wafv2RuleGroupRule {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#name Wafv2RuleGroup#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#priority Wafv2RuleGroup#priority}
    */
    readonly priority: number;
    /**
    * action block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#action Wafv2RuleGroup#action}
    */
    readonly action: Wafv2RuleGroupRuleAction;
    /**
    * captcha_config block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#captcha_config Wafv2RuleGroup#captcha_config}
    */
    readonly captchaConfig?: Wafv2RuleGroupRuleCaptchaConfig;
    /**
    * rule_label block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#rule_label Wafv2RuleGroup#rule_label}
    */
    readonly ruleLabel?: Wafv2RuleGroupRuleRuleLabel[] | cdktf.IResolvable;
    /**
    * statement block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#statement Wafv2RuleGroup#statement}
    */
    readonly statement: Wafv2RuleGroupRuleStatement;
    /**
    * visibility_config block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#visibility_config Wafv2RuleGroup#visibility_config}
    */
    readonly visibilityConfig: Wafv2RuleGroupRuleVisibilityConfig;
}
export declare function wafv2RuleGroupRuleToTerraform(struct?: Wafv2RuleGroupRule | cdktf.IResolvable): any;
export declare class Wafv2RuleGroupRuleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): Wafv2RuleGroupRule | cdktf.IResolvable | undefined;
    set internalValue(value: Wafv2RuleGroupRule | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _priority?;
    get priority(): number;
    set priority(value: number);
    get priorityInput(): number | undefined;
    private _action;
    get action(): Wafv2RuleGroupRuleActionOutputReference;
    putAction(value: Wafv2RuleGroupRuleAction): void;
    get actionInput(): Wafv2RuleGroupRuleAction | undefined;
    private _captchaConfig;
    get captchaConfig(): Wafv2RuleGroupRuleCaptchaConfigOutputReference;
    putCaptchaConfig(value: Wafv2RuleGroupRuleCaptchaConfig): void;
    resetCaptchaConfig(): void;
    get captchaConfigInput(): Wafv2RuleGroupRuleCaptchaConfig | undefined;
    private _ruleLabel;
    get ruleLabel(): Wafv2RuleGroupRuleRuleLabelList;
    putRuleLabel(value: Wafv2RuleGroupRuleRuleLabel[] | cdktf.IResolvable): void;
    resetRuleLabel(): void;
    get ruleLabelInput(): cdktf.IResolvable | Wafv2RuleGroupRuleRuleLabel[] | undefined;
    private _statement;
    get statement(): Wafv2RuleGroupRuleStatementOutputReference;
    putStatement(value: Wafv2RuleGroupRuleStatement): void;
    get statementInput(): Wafv2RuleGroupRuleStatement | undefined;
    private _visibilityConfig;
    get visibilityConfig(): Wafv2RuleGroupRuleVisibilityConfigOutputReference;
    putVisibilityConfig(value: Wafv2RuleGroupRuleVisibilityConfig): void;
    get visibilityConfigInput(): Wafv2RuleGroupRuleVisibilityConfig | undefined;
}
export declare class Wafv2RuleGroupRuleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: Wafv2RuleGroupRule[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): Wafv2RuleGroupRuleOutputReference;
}
export interface Wafv2RuleGroupVisibilityConfig {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#cloudwatch_metrics_enabled Wafv2RuleGroup#cloudwatch_metrics_enabled}
    */
    readonly cloudwatchMetricsEnabled: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#metric_name Wafv2RuleGroup#metric_name}
    */
    readonly metricName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.31.0/docs/resources/wafv2_rule_group#sampled_requests_enabled Wafv2RuleGroup#sampled_requests_enabled}
    */
    readonly sampledRequestsEnabled: boolean | cdktf.IResolvable;
}
export declare function wafv2RuleGroupVisibilityConfigToTerraform(struct?: Wafv2RuleGroupVisibilityConfigOutputReference | Wafv2RuleGroupVisibilityConfig): any;
export declare class Wafv2RuleGroupVisibilityConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): Wafv2RuleGroupVisibilityConfig | undefined;
    set internalValue(value: Wafv2RuleGroupVisibilityConfig | undefined);
    private _cloudwatchMetricsEnabled?;
    get cloudwatchMetricsEnabled(): boolean | cdktf.IResolvable;
    set cloudwatchMetricsEnabled(value: boolean | cdktf.IResolvable);
    get cloudwatchMetricsEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _metricName?;
    get metricName(): string;
    set metricName(value: string);
    get metricNameInput(): string | undefined;
    private _sampledRequestsEnabled?;
    get sampledRequestsEnabled(): boolean | cdktf.IResolvable;
    set sampledRequestsEnabled(value: boolean | cdktf.IResolvable);
    get sampledRequestsEnabledInput(): boolean | cdktf.IResolvable | undefined;
}
